% Examples

% First make sure that you have access to the TclODBC module
declare
[TclODBC] = {Module.link ['tclodbc.ozf']}

declare
DSO = {New TclODBC.odbc init}
{Browse {DSO drivers($)}}
{Browse {DSO datasources($)}}

% Build database, data source, tables, and indexes

declare
DSN = testdb

% the default Driver = 'Microsoft Access Driver (*.mdb)'
declare
Driver = 'Microsoft Access Driver (*.mdb)'

% Create a database file
{DSO configure(operation:config_dsn args:l(list s('CREATE_DB=c:\\OzODBC\\testdb.mdb' 'General')))}

% Create user data source
{DSO configure(args:l(list s('DSN=testdb') s('DBQ=c:\\OzODBC\\testdb.mdb')))}

% Connect to the database through the data source name
{DSO connect(name:DSN)}

% Creates a table
{DSO sql(DSN q('CREATE' 'TABLE' 'Table1' '(IntData' 'INTEGER,' 'CharData' 'CHAR' '(20),' 'DateData' 'DATE)'))}

% Create indexes
{DSO sql(DSN q('CREATE' 'UNIQUE' 'INDEX' 'Table1_Ix1' 'ON' 'Table1' '(IntData)'))}
{DSO sql(DSN q('CREATE' 'INDEX' 'Table1_Ix2' 'ON' 'Table1' '(CharData,' 'DateData)'))}

{Browse {DSO tables(DSN $)}}
{Browse {DSO dbcolumns(DSN $)}}
{Browse {DSO tablecolumns(DSN 'Table1' $)}}
{Browse {DSO indexes(DSN 'Table1' $)}}

% One can use STRING type for the SQL statement
{DSO sql(DSN "INSERT INTO TABLE1 (IntData, CharData, DateData) VALUES (10853, 'A., R.', '10/08/53')")}

% Or can use Virtual String
{DSO sql(DSN "INSERT INTO TABLE1 ("#"IntData"#", "#"CharData"#", "#"DateData"#") "#"VALUES ("#"10854"#", "#"'J., S.'"#", "#"'10/08/54'"#")")}

% Or can use Tickles
{Browse {DSO sqlReturn(DSN o(select '*' 'from' 'Table1' where 'IntData' '=' '10853') $)}}

{DSO statement(DSN stmt o(s("select * from Table1 where IntData=?") 'INTEGER'))}
{Browse {DSO stmt(stmt('10853') $)}}

{DSO statement(DSN stmt "select * from Table1 where IntData = 10853")}
% In Mozart you cannot send a tcl command without args.
{Browse {DSO stmt(stmt('') $)}}

{DSO drop(stmt)}

% Delete indexes, tables, and data sourcedeclare
{DSO sql(DSN q('DROP' 'INDEX' 'Table1_Ix2' 'ON' 'Table1'))}
{DSO sql(DSN q('DROP' 'INDEX' 'Table1_Ix1' 'ON' 'Table1'))}
{DSO sql(DSN q('DROP' 'TABLE' 'Table1'))}

% Close the connection with the database
{DSO disconnect(DSN)}

% Remove the data source from the system
{DSO configure(operation:remove_dsn driver:Driver args:l(list s('DSN=testdb') s('DBQ=c:\\OzODBC\\testdb.mdb') 'General'))}

% Unload the package
{DSO forget}
